using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Linq;

namespace Minecraft
{
    public class Start
    {
        public static void Main()
        {
            ModAPI.RegisterTool<MinecraftMainScript>("Minecraft build", "", ModAPI.LoadSprite("InGameIcon.png"));// 

            CategoryBuilder.Create("Minecraft", "",ModAPI.LoadSprite("InGameIcon.png"));

            List<string> blockDatas_Name = new List<string>(){
                "water",
                "acacia_leaves",
                "beacon",
                "beetroots_stage_0",
                "beetroots_stage_1",
                "beetroots_stage_2",
                "beetroots_stage_3",
                "birch_leaves",
                "bone_block_side",
                "bookshelf",
                "brick",
                "cactus_side",
                "cake_side",
                "carrots_stage_0",
                "carrots_stage_1",
                "carrots_stage_2",
                "carrots_stage_3",
                "cauldron_side",
                "chorus_flower",
                "chorus_flower_dead",
                "chorus_plant",
                "clay",
                "coal_block",
                "coal_ore",
                "cobblestone",
                "cobblestone_mossy",
                "crafting_table_front",
                "crafting_table_side",
                "dark_oak_leaves",
                "deadbush",
                "diamond_block",
                "diamond_ore",
                "dirt",
                "dispenser_front_horizontal",
                "dispenser_front_vertical",
                "double_plant_paeonia_bottom",
                "double_plant_paeonia_top",
                "double_plant_rose_bottom",
                "double_plant_rose_top",
                "double_plant_sunflower_back",
                "double_plant_sunflower_bottom",
                "double_plant_sunflower_front",
                "double_plant_sunflower_top",
                "double_plant_syringa_bottom",
                "double_plant_syringa_top",
                "dropper_front_horizontal",
                "dropper_front_vertical",
                "emerald_block",
                "emerald_ore",
                "enchanting_table_bottom",
                "enchanting_table_side",
                "end_bricks",
                "end_stone",
                "endframe_side",
                "flower_allium",
                "flower_blue_orchid",
                "flower_dandelion",
                "flower_houstonia",
                "flower_oxeye_daisy",
                "flower_paeonia",
                "flower_rose",
                "flower_tulip_orange",
                "flower_tulip_pink",
                "flower_tulip_red",
                "flower_tulip_white",
                "frosted_ice_0",
                "frosted_ice_1",
                "frosted_ice_2",
                "frosted_ice_3",
                "furnace_front_off",
                "furnace_front_on",
                "furnace_side",
                "glass",
                "glass_black",
                "glass_blue",
                "glass_brown",
                "glass_gray",
                "glass_green",
                "glass_light_blue",
                "glass_lime",
                "glass_magenta",
                "glass_orange",
                "glass_pink",
                "glass_purple",
                "glass_red",
                "glass_silver",
                "glass_white",
                "glass_yellow",
                "glowstone",
                "gold_block",
                "gold_ore",
                "grass_block",
                "grass_path_side",
                "gravel",
                "hardened_clay",
                "hay_block_side",
                "hay_block_top",
                "ice",
                "ice_packed",
                "iron_bars",
                "iron_block",
                "iron_ore",
                "iron_trapdoor",
                "itemframe_background",
                "jukebox_side",
                "jungle_leaves",
                "ladder",
                "lapis_block",
                "lapis_ore",
                "lever",
                "log_acacia",
                "log_acacia_top",
                "log_big_oak",
                "log_big_oak_top",
                "log_birch",
                "log_birch_top",
                "log_jungle",
                "log_jungle_top",
                "log_oak",
                "log_oak_top",
                "log_spruce",
                "log_spruce_top",
                "melon_side",
                "melon_top",
                "mob_spawner",
                "mushroom_block_inside",
                "mushroom_block_skin_brown",
                "mushroom_block_skin_red",
                "mushroom_block_skin_stem",
                "mushroom_brown",
                "mushroom_red",
                "mycelium_side",
                "mycelium_top",
                "nether_brick",
                "nether_wart_block",
                "nether_wart_stage_0",
                "nether_wart_stage_1",
                "nether_wart_stage_2",
                "netherrack",
                "noteblock",
                "oak_leaves",
                "observer_back",
                "observer_back_lit",
                "observer_front",
                "observer_side",
                "observer_top",
                "obsidian",
                "piston_inner",
                "piston_side",
                "piston_top_normal",
                "piston_top_sticky",
                "planks_acacia",
                "planks_big_oak",
                "planks_birch",
                "planks_jungle",
                "planks_oak",
                "planks_spruce",
                "potatoes_stage_0",
                "potatoes_stage_1",
                "potatoes_stage_2",
                "potatoes_stage_3",
                "prismarine_bricks",
                "prismarine_dark",
                "pumpkin_face_off",
                "pumpkin_face_on",
                "pumpkin_side",
                "pumpkin_top",
                "purpur_block",
                "purpur_pillar",
                "purpur_pillar_top",
                "quartz_block_bottom",
                "quartz_block_chiseled",
                "quartz_block_chiseled_top",
                "quartz_block_lines",
                "quartz_block_lines_top",
                "quartz_block_side",
                "quartz_block_top",
                "quartz_ore",
                "red_nether_brick",
                "red_sand",
                "red_sandstone_bottom",
                "red_sandstone_carved",
                "red_sandstone_normal",
                "red_sandstone_smooth",
                "red_sandstone_top",
                "redstone_block",
                "redstone_lamp_off",
                "redstone_lamp_on",
                "redstone_ore",
                "redstone_torch_off",
                "redstone_torch_on",
                "sand",
                "sandstone_bottom",
                "sandstone_carved",
                "sandstone_normal",
                "sandstone_smooth",
                "sandstone_top",
                "sapling_acacia",
                "sapling_birch",
                "sapling_jungle",
                "sapling_oak",
                "sapling_roofed_oak",
                "sapling_spruce",
                "slime",
                "snow",
                "soul_sand",
                "sponge",
                "sponge_wet",
                "spruce_leaves",
                "stone",
                "stone_andesite",
                "stone_andesite_smooth",
                "stone_diorite",
                "stone_diorite_smooth",
                "stone_granite",
                "stone_granite_smooth",
                "stone_slab_side",
                "stone_slab_top",
                "stonebrick",
                "stonebrick_carved",
                "stonebrick_cracked",
                "stonebrick_mossy",
                "tnt_side",
                "torch_on",
                "trapdoor",
                "trip_wire_source",
                "wheat_stage_0",
                "wheat_stage_1",
                "wheat_stage_2",
                "wheat_stage_3",
                "wheat_stage_4",
                "wheat_stage_5",
                "wheat_stage_6",
                "wheat_stage_7",
                "oak_ladder",
                "spruce_ladder",
                "acacia_ladder",
                "birch_ladder",
                "big_oak_ladder",
                "bedrock"
            };
            foreach (string name in blockDatas_Name)
                ModAPI.Register(
                new Modification()
                {
                  OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = name, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "", //new item description
                    CategoryOverride = ModAPI.FindCategory("Minecraft"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Sprites/" + name + ".png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        if(UnityEngine.Object.FindObjectOfType<MinecraftMainScript>() != null) UnityEngine.Object.FindObjectOfType<MinecraftMainScript>().SelectBlockMethod(name);
                        UnityEngine.Object.Destroy(Instance);
                    }
                });


            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Dynamite"), //item to derive from
                NameOverride = "TNT", //new item name with a suffix to assure it is globally unique
                DescriptionOverride = "It is a dagger.", //new item description
                CategoryOverride = ModAPI.FindCategory("Explosives"), //new item category
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/tnt_side.png"), //new item thumbnail (relative path)
                AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                {
                    TNT tnt = Instance.AddComponent<TNT>();
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/tnt_side.png", 1f / 2.5f); //get the SpriteRenderer and replace its sprite with a custom one
                    Instance.transform.localScale = new Vector3(2,2,2);
                    Instance.FixColliders();

                    Instance.AddComponent<UseEventTrigger>().Action = () =>
                    {
                        tnt.Explosive(Instance.transform.position);
                    };
                }
            }
            );
        }
    }

    public class Block : MonoBehaviour { 
        public bool TNTDestroyed = false; 
    }

    public class TNT : MonoBehaviour
    {
        public void Explosive(Vector3 Pos)
        {


            Block[] Blocks = UnityEngine.Object.FindObjectsOfType(typeof(Block)) as Block[];
            Rigidbody2D[] BlocksRB = UnityEngine.Object.FindObjectsOfType(typeof(Rigidbody2D)) as Rigidbody2D[];
            List<GameObject> FilterBlocks = new List<GameObject>();

            foreach (Rigidbody2D obj in BlocksRB)
            {
                if (Vector2.Distance((Vector2)Pos, obj.gameObject.transform.position) < 5)
                {
                    obj.AddForceAtPosition((Pos- obj.transform.position) * 50, Pos);
                }
            }
            foreach (Block obj in Blocks)
            {
                if (Vector2.Distance((Vector2)Pos, obj.gameObject.transform.position) < 5)
                {
                    if (!obj.TNTDestroyed)
                    {
                        GameObject Obj = ModAPI.CreatePhysicalObject("NewBlock", obj.gameObject.GetComponent<SpriteRenderer>().sprite);
                        Obj.transform.localScale = obj.transform.localScale;
                        Obj.transform.position = obj.transform.position;
                        Obj.GetComponent<PhysicalBehaviour>().SpawnSpawnParticles = false;
                        Obj.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                        Obj.GetComponent<BoxCollider2D>().size = new Vector2(Obj.GetComponent<BoxCollider2D>().size.x - 0.02f, Obj.GetComponent<BoxCollider2D>().size.y - 0.02f);
                        Obj.GetComponent<PhysicalBehaviour>().rigidbody.AddForceAtPosition((Pos - obj.transform.position) * 50, Pos);
                    }

                    UnityEngine.Object.Destroy(obj.gameObject);
                }
            }
        }
        void OnDestroy()
        {
            Explosive(transform.position);
        }

    }

    public class MinecraftMainScript : ToolBehaviour
    {
        public GameObject Block;
        public bool Build;
        public bool RemoveMode;

        public string SelectBlock = "brick";
                public List<UnityEngine.Sprite> blockDatas_Sprite = new List<UnityEngine.Sprite>();
        public List<string> blockDatas_Name = new List<string>();

        public DialogBox dialog = (DialogBox)null;

        public Vector3 Rotation;


        public const float CellSize = 0.4571f * 2.5f;




        void Awake()
        {
            blockDatas_Name = new List<string>(){
                "water",
                "acacia_leaves",
                "beacon",
                "beetroots_stage_0",
                "beetroots_stage_1",
                "beetroots_stage_2",
                "beetroots_stage_3",
                "birch_leaves",
                "bone_block_side",
                "bookshelf",
                "brick",
                "cactus_side",
                "cake_side",
                "carrots_stage_0",
                "carrots_stage_1",
                "carrots_stage_2",
                "carrots_stage_3",
                "cauldron_side",
                "chorus_flower",
                "chorus_flower_dead",
                "chorus_plant",
                "clay",
                "coal_block",
                "coal_ore",
                "cobblestone",
                "cobblestone_mossy",
                "crafting_table_front",
                "crafting_table_side",
                "dark_oak_leaves",
                "deadbush",
                "diamond_block",
                "diamond_ore",
                "dirt",
                "dispenser_front_horizontal",
                "dispenser_front_vertical",
                "double_plant_paeonia_bottom",
                "double_plant_paeonia_top",
                "double_plant_rose_bottom",
                "double_plant_rose_top",
                "double_plant_sunflower_back",
                "double_plant_sunflower_bottom",
                "double_plant_sunflower_front",
                "double_plant_sunflower_top",
                "double_plant_syringa_bottom",
                "double_plant_syringa_top",
                "dropper_front_horizontal",
                "dropper_front_vertical",
                "emerald_block",
                "emerald_ore",
                "enchanting_table_bottom",
                "enchanting_table_side",
                "end_bricks",
                "end_stone",
                "endframe_side",
                "flower_allium",
                "flower_blue_orchid",
                "flower_dandelion",
                "flower_houstonia",
                "flower_oxeye_daisy",
                "flower_paeonia",
                "flower_rose",
                "flower_tulip_orange",
                "flower_tulip_pink",
                "flower_tulip_red",
                "flower_tulip_white",
                "frosted_ice_0",
                "frosted_ice_1",
                "frosted_ice_2",
                "frosted_ice_3",
                "furnace_front_off",
                "furnace_front_on",
                "furnace_side",
                "glass",
                "glass_black",
                "glass_blue",
                "glass_brown",
                "glass_gray",
                "glass_green",
                "glass_light_blue",
                "glass_lime",
                "glass_magenta",
                "glass_orange",
                "glass_pink",
                "glass_purple",
                "glass_red",
                "glass_silver",
                "glass_white",
                "glass_yellow",
                "glowstone",
                "gold_block",
                "gold_ore",
                "grass_block",
                "grass_path_side",
                "gravel",
                "hardened_clay",
                "hay_block_side",
                "hay_block_top",
                "ice",
                "ice_packed",
                "iron_bars",
                "iron_block",
                "iron_ore",
                "iron_trapdoor",
                "itemframe_background",
                "jukebox_side",
                "jungle_leaves",
                "ladder",
                "lapis_block",
                "lapis_ore",
                "lever",
                "log_acacia",
                "log_acacia_top",
                "log_big_oak",
                "log_big_oak_top",
                "log_birch",
                "log_birch_top",
                "log_jungle",
                "log_jungle_top",
                "log_oak",
                "log_oak_top",
                "log_spruce",
                "log_spruce_top",
                "melon_side",
                "melon_top",
                "mob_spawner",
                "mushroom_block_inside",
                "mushroom_block_skin_brown",
                "mushroom_block_skin_red",
                "mushroom_block_skin_stem",
                "mushroom_brown",
                "mushroom_red",
                "mycelium_side",
                "mycelium_top",
                "nether_brick",
                "nether_wart_block",
                "nether_wart_stage_0",
                "nether_wart_stage_1",
                "nether_wart_stage_2",
                "netherrack",
                "noteblock",
                "oak_leaves",
                "observer_back",
                "observer_back_lit",
                "observer_front",
                "observer_side",
                "observer_top",
                "obsidian",
                "piston_inner",
                "piston_side",
                "piston_top_normal",
                "piston_top_sticky",
                "planks_acacia",
                "planks_big_oak",
                "planks_birch",
                "planks_jungle",
                "planks_oak",
                "planks_spruce",
                "potatoes_stage_0",
                "potatoes_stage_1",
                "potatoes_stage_2",
                "potatoes_stage_3",
                "prismarine_bricks",
                "prismarine_dark",
                "pumpkin_face_off",
                "pumpkin_face_on",
                "pumpkin_side",
                "pumpkin_top",
                "purpur_block",
                "purpur_pillar",
                "purpur_pillar_top",
                "quartz_block_bottom",
                "quartz_block_chiseled",
                "quartz_block_chiseled_top",
                "quartz_block_lines",
                "quartz_block_lines_top",
                "quartz_block_side",
                "quartz_block_top",
                "quartz_ore",
                "red_nether_brick",
                "red_sand",
                "red_sandstone_bottom",
                "red_sandstone_carved",
                "red_sandstone_normal",
                "red_sandstone_smooth",
                "red_sandstone_top",
                "redstone_block",
                "redstone_lamp_off",
                "redstone_lamp_on",
                "redstone_ore",
                "redstone_torch_off",
                "redstone_torch_on",
                "sand",
                "sandstone_bottom",
                "sandstone_carved",
                "sandstone_normal",
                "sandstone_smooth",
                "sandstone_top",
                "sapling_acacia",
                "sapling_birch",
                "sapling_jungle",
                "sapling_oak",
                "sapling_roofed_oak",
                "sapling_spruce",
                "slime",
                "snow",
                "soul_sand",
                "sponge",
                "sponge_wet",
                "spruce_leaves",
                "stone",
                "stone_andesite",
                "stone_andesite_smooth",
                "stone_diorite",
                "stone_diorite_smooth",
                "stone_granite",
                "stone_granite_smooth",
                "stone_slab_side",
                "stone_slab_top",
                "stonebrick",
                "stonebrick_carved",
                "stonebrick_cracked",
                "stonebrick_mossy",
                "tnt_side",
                "torch_on",
                "trapdoor",
                "trip_wire_source",
                "wheat_stage_0",
                "wheat_stage_1",
                "wheat_stage_2",
                "wheat_stage_3",
                "wheat_stage_4",
                "wheat_stage_5",
                "wheat_stage_6",
                "wheat_stage_7",
                "oak_ladder",
                "spruce_ladder",
                "acacia_ladder",
                "birch_ladder",
                "big_oak_ladder",
                "bedrock"
            };
            foreach (string name in blockDatas_Name)
            {
                blockDatas_Sprite.Add(ModAPI.LoadSprite("Sprites/" + name + ".png",1f/2.5f));
            }
        }


        int Flip = 1;

        public UnityEngine.GameObject CreateBlock(float X, float Y, string BlockID,bool Collider)
        {
            if(GameObject.Find("Block(" + X * CellSize + "," + Y * CellSize + ")") != null) UnityEngine.Object.Destroy(GameObject.Find("Block(" + X*CellSize + "," + Y*CellSize + ")"));

            UnityEngine.GameObject Block = new UnityEngine.GameObject("NewBlock");

            Block.AddComponent<SpriteRenderer>().sprite = blockDatas_Sprite[blockDatas_Name.IndexOf(BlockID)];

            Block.transform.localScale = Vector2.one * 2.5f;

            if (Collider)Block.AddComponent<BoxCollider2D>();
            Block.layer = 9;
            Block.transform.localScale = new Vector3(Block.transform.localScale.x * Flip, Block.transform.localScale.y, 1);

            Block.transform.position = new Vector3(X * CellSize, Y * CellSize);
            Block.name = "Block(" + X * CellSize + "," + Y * CellSize + ")";
            if (BlockID != "water") Block.AddComponent<Block>();
            else
            {
                Minecraft.Block BlockScript = Block.AddComponent<Block>();
                BlockScript.TNTDestroyed = true;

                Block.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
            }
            return Block;
        }
        public void SelectBlockMethod(string Name)
        {
            if (Build)
            {
                if (Block != null) UnityEngine.Object.Destroy(Block);
                if (blockDatas_Name.Contains(SelectBlock))
                {
                    Block = ModAPI.CreatePhysicalObject("NewBlock", blockDatas_Sprite[blockDatas_Name.IndexOf(Name)]);
                    Block.transform.localScale = new Vector3(2.5f * Flip, 2.5f, 1);

                    UnityEngine.Color32 Color = UnityEngine.Color.white;
                    Color.a = 50;
                    Block.GetComponent<SpriteRenderer>().color = Color;

                    Block.GetComponent<PhysicalBehaviour>().SpawnSpawnParticles = false;
                    Block.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                    Block.AddComponent<FreezeBehaviour>();

                    Block.FixColliders();

                    SelectBlock = Name;
                }
            }
        }

        public override void OnHold()
        {
            if (Block != null)
            {
                if (RemoveMode)
                {
                    UnityEngine.Object.Destroy(GameObject.Find("Block(" + Pos.x + "," + Pos.y + ")"));
                }
                else
                {
                    if (GameObject.Find("Block(" + Pos.x + "," + Pos.y + ")") == null)
                    {
                        Block.name = "Block(" + Pos.x + "," + Pos.y + ")";
                        Block.transform.position = Pos;

                        UnityEngine.Color32 Color = UnityEngine.Color.white;
                        Color.a = 255;
                        Block.GetComponent<SpriteRenderer>().color = Color;

                        Block.AddComponent<Block>();

                        Block = ModAPI.CreatePhysicalObject("NewBlock", blockDatas_Sprite[blockDatas_Name.IndexOf(SelectBlock)]);
                        Block.transform.localScale = new Vector3(2.5f * Flip, 2.5f, 1);

                        Block.GetComponent<PhysicalBehaviour>().SpawnSpawnParticles = false;
                        Block.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        Block.AddComponent<FreezeBehaviour>();

                        Block.FixColliders();
                    }
                }
            }
        }
        public override void OnSelect() { }
        public override void OnDeselect() { }
        public override void OnFixedHold() { }
        public override void OnToolChosen() {
            if (blockDatas_Name.Contains(SelectBlock))
            {
                Block = ModAPI.CreatePhysicalObject("NewBlock", blockDatas_Sprite[blockDatas_Name.IndexOf(SelectBlock)]);
                Block.transform.localScale = new Vector3(2.5f * Flip, 2.5f, 1);

                UnityEngine.Color32 Color = UnityEngine.Color.white;
                Color.a = 50;
                Block.GetComponent<SpriteRenderer>().color = Color;

                Block.GetComponent<PhysicalBehaviour>().SpawnSpawnParticles = false;
                Block.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                Block.AddComponent<FreezeBehaviour>();

                Block.FixColliders();
            }
            Build = true;
        }
        public override void OnToolUnchosen()
        {
            UnityEngine.Object.Destroy(Block);
            Build = false;
        }

        void Update()
        {
            if (Block != null)
            {
                Block.transform.rotation = Quaternion.Euler(Rotation);
                Block.transform.position = Pos;
                if (GameObject.Find("Block(" + Pos.x + "," + Pos.y + ")") != null)
                {
                    UnityEngine.Color32 Color = UnityEngine.Color.red;
                    Color.a = 175;
                    Block.GetComponent<SpriteRenderer>().color = Color;
                }
                else
                {
                    UnityEngine.Color32 Color = UnityEngine.Color.white;
                    Color.a = 50;
                    Block.GetComponent<SpriteRenderer>().color = Color;
                }
            }

            if (Input.GetKeyDown(KeyCode.L) && dialog == null)
            {
                dialog = DialogBoxManager.TextEntry("Enter the name of the block to select", "Text", new DialogButton("Apply", true, new UnityAction[1]
                {
                            (UnityAction)(() => {
                                UnityEngine.Object.Destroy(Block);
                                foreach(string CurrectName in blockDatas_Name)
                                {
                                    if ((string)dialog.EnteredText == CurrectName)
                                    {
                                        ModAPI.Notify("Succes selected block: <color=green>"+CurrectName+"</color>");
                                        SelectBlock = CurrectName;
                                        break;
                                    }
                                }
                                dialog = null;
                            })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
                ;
            }

            if (Input.GetKeyDown(KeyCode.D) && dialog == null && Build)
            {
                Rotation.z -= 90;
            }
            if (Input.GetKeyDown(KeyCode.A) && dialog == null && Build)
            {
                Rotation.z += 90;
            }
            if (Input.GetKeyDown(KeyCode.X) && dialog == null && Build)
            {
                RemoveMode = !RemoveMode;
                ModAPI.Notify("Remove mode status: <color=green>"+RemoveMode+"</color>");
            }
                if (Input.GetKeyDown(KeyCode.R) && dialog == null && Build)
            {
                Flip *= -1;
                Block.transform.localScale = new Vector3(Block.transform.localScale.x * -1, Block.transform.localScale.y, 1);
                ModAPI.Notify("Block succes <color=green>flipped</color>");
            }

            if (Input.GetKeyDown(KeyCode.P) && dialog == null)
            {
                dialog = DialogBoxManager.TextEntry("Write <color=red>length</color>:", "Text", new DialogButton("Apply", true, new UnityAction[1]
{
                            (UnityAction)(() => {
                                Generate(int.Parse((string)dialog.EnteredText));
                                dialog = null;
                            })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
                ;
            }
        }
        void FixedUpdate()
        {
            Pos = new Vector3(UnityEngine.Mathf.Round(Global.main.MousePosition.x / CellSize) * CellSize, UnityEngine.Mathf.Round(Global.main.MousePosition.y / CellSize) * CellSize, 0);
        }
        Vector3 Pos;


        private void Generate(float Length)
        {
            float MinimumY = 2;
            float Y = MinimumY + 10;

            bool Water = false;// 
            float WaterLength = 0;
            float WaterLevel = 0;
            float LastY = Y;
            float StartWaterX = 0;
            float LowerWater = 10000;

            float Rand = 0;

            for (float X = 0; X < Length; X++)//
            {
                if (X % 2 == 0) 
                {
                    Rand = UnityEngine.Random.Range(-1, 2);
                    if (WaterLength > 3 || Rand < 0)
                    LastY = Y; 
                    Y += Rand;
                }
                CreateBlock(X, MinimumY - 1, "bedrock",true);

                Y = UnityEngine.Mathf.Clamp(Y, MinimumY+5, Mathf.Infinity);

                if (!Water && LastY >= Y)// 
                {
                    Rand = UnityEngine.Random.Range(0, 101);
                    if(Rand > 95)
                    {
                        Water = true;
                        WaterLevel = Y;
                        WaterLength = 1;
                        StartWaterX = X;
                        LowerWater = 1000;
                    }
                }
                else
                {
                    WaterLength++;
                    if ((WaterLevel + 1 == Y)||X == Length-1)
                    {
                        if(X != Length - 1) Water = false;
                    }
                    if (Y < LowerWater) LowerWater = Y;
                }

                if (!Water)
                {
                    CreateBlock(X, Y, "grass_block",true);
                }
                else
                {
                    GameObject WaterObj = CreateBlock(X, WaterLevel, "water",false);

                    for(float _Y = Y; _Y < WaterLevel; _Y++)
                    {
                        WaterObj = CreateBlock(X, _Y, "water",false);
                    }
                }

                float GrassLvl = UnityEngine.Random.Range(1, 4);
                for (float _Y = MinimumY; _Y < Y; _Y++)
                {
                    if (Y - _Y <= GrassLvl) { if (!Water) CreateBlock(X, _Y, "dirt", true); else CreateBlock(X, _Y, "sand", true); }
                    else
                    {
                        float rand = UnityEngine.Random.Range(0, 101);
                        if (rand < 90) CreateBlock(X, _Y, "stone", true);
                        else
                        {
                            rand = UnityEngine.Random.Range(0, 101);
                            if (rand < 70) CreateBlock(X, _Y, "coal_ore", true);
                            else
                            {
                                rand = UnityEngine.Random.Range(0, 3);
                                if (rand == 0) CreateBlock(X, _Y, "iron_ore", true);
                                if (rand == 1) CreateBlock(X, _Y, "gold_ore", true);
                                if (rand == 2) CreateBlock(X, _Y, "diamond_ore", true);
                            }
                        }
                    }
                }


                if (!Water)
                {
                    if (Rand >= 87)//
                    {
                        Rand = UnityEngine.Random.Range(0, 2);
                        if (Rand == 0) TreeGenerate("log_oak", "oak_leaves", new Vector2(X, Y));
                        if (Rand == 1) TreeGenerate("log_birch", "birch_leaves", new Vector2(X, Y));
                    }
                    else
                    {
                        if (Rand > 40)//
                        {
                            Rand = UnityEngine.Random.Range(0, 4);
                            if (Rand == 0)
                                CreateBlock(X, Y + 1, "flower_tulip_red", false);
                            if (Rand == 1)
                                CreateBlock(X, Y + 1, "flower_tulip_white", false);

                            if (Rand == 2)
                                CreateBlock(X, Y + 1, "flower_dandelion", false);

                            if (Rand == 3)
                                CreateBlock(X, Y + 1, "wheat_stage_7", false);
                        }
                    }
                }
            }
        }

        public void TreeGenerate(string Log, string Leaves, Vector2 Pos)
        {
            CreateBlock(Pos.x, Pos.y + 1, Log, true);
            CreateBlock(Pos.x, Pos.y + 2, Log, true);
            CreateBlock(Pos.x, Pos.y + 3, Log, true);
            CreateBlock(Pos.x, Pos.y + 4, Log, true);


            CreateBlock(Pos.x - 1, Pos.y + 2, Leaves, true);
            CreateBlock(Pos.x - 2, Pos.y + 2, Leaves, true);
            CreateBlock(Pos.x + 1, Pos.y + 2, Leaves, true);
            CreateBlock(Pos.x + 2, Pos.y + 2, Leaves, true);


            CreateBlock(Pos.x - 1, Pos.y + 3, Leaves, true);
            CreateBlock(Pos.x - 2, Pos.y + 3, Leaves, true);
            CreateBlock(Pos.x + 1, Pos.y + 3, Leaves, true);
            CreateBlock(Pos.x + 2, Pos.y + 3, Leaves, true);

            CreateBlock(Pos.x - 1, Pos.y + 4, Leaves, true);
            CreateBlock(Pos.x - 2, Pos.y + 4, Leaves, true);
            CreateBlock(Pos.x + 1, Pos.y + 4, Leaves, true);
            CreateBlock(Pos.x + 2, Pos.y + 4, Leaves, true);

            CreateBlock(Pos.x - 1, Pos.y + 5, Leaves, true);
            CreateBlock(Pos.x, Pos.y + 5, Leaves, true);
            CreateBlock(Pos.x + 1, Pos.y + 5, Leaves, true);
        }
    }


}